Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/GenealogyGraphChart.Designer.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/GenealogyGraphChart.Designer.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/GenealogyGraphChart.Designer.cs	(revision 10300)
@@ -1,9 +1,5 @@
-﻿using HeuristicLab.Core;
-
+﻿
 namespace HeuristicLab.EvolutionTracking.Views {
-  partial class GenealogyGraphChart<TGraph, TVertex, TContent>
-    where TGraph : class, IGenealogyGraph<TVertex, TContent>
-    where TVertex : class, IGenealogyGraphNode<TContent>, new()
-    where TContent : class, IItem {
+  partial class GenealogyGraphChart {
     /// <summary> 
     /// Required designer variable.
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/GenealogyGraphChart.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/GenealogyGraphChart.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/GenealogyGraphChart.cs	(revision 10300)
@@ -6,13 +6,9 @@
 using System.Windows.Forms;
 using HeuristicLab.Common;
-using HeuristicLab.Core;
 using HeuristicLab.Visualization;
 
 namespace HeuristicLab.EvolutionTracking.Views {
-  public partial class GenealogyGraphChart<TGraph, TVertex, TContent> : ChartControl
-    where TGraph : class, IGenealogyGraph<TVertex, TContent>
-    where TVertex : class, IGenealogyGraphNode<TContent>, new()
-    where TContent : class,IItem {
-    private TGraph genealogyGraph;
+  public partial class GenealogyGraphChart : ChartControl {
+    private IGenealogyGraph genealogyGraph;
 
     private const double XIncrement = 30;
@@ -20,5 +16,5 @@
     private const double Diameter = 20;
 
-    public TGraph GenealogyGraph {
+    public IGenealogyGraph GenealogyGraph {
       get { return genealogyGraph; }
       set {
@@ -109,5 +105,5 @@
 
       // add arcs
-      foreach (var node in GenealogyGraph.Nodes) {
+      foreach (var node in GenealogyGraph.Nodes.Cast<IGenealogyGraphNode>()) {
         if (node.InArcs == null) continue;
         var visualNode = nodeMap[node];
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/GenealogyGraphView.Designer.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/GenealogyGraphView.Designer.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/GenealogyGraphView.Designer.cs	(revision 10300)
@@ -1,3 +1,3 @@
-﻿
+﻿using HeuristicLab.Visualization;
 
 namespace HeuristicLab.EvolutionTracking.Views {
@@ -26,96 +26,26 @@
     /// </summary>
     private void InitializeComponent() {
-      this.components = new System.ComponentModel.Container();
-      this.topControlBox = new System.Windows.Forms.Panel();
-      this.graphControlsGroupBox = new System.Windows.Forms.GroupBox();
-      this.lockGenealogyCheckBox = new System.Windows.Forms.CheckBox();
-      this.highlightAllButton = new System.Windows.Forms.Button();
-      this.simpleLineagesCheckBox = new System.Windows.Forms.CheckBox();
-      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       this.genealogyGraphChart = new HeuristicLab.EvolutionTracking.Views.GenealogyGraphChart();
-      this.topControlBox.SuspendLayout();
-      this.graphControlsGroupBox.SuspendLayout();
       this.SuspendLayout();
-      // 
-      // topControlBox
-      // 
-      this.topControlBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.topControlBox.Controls.Add(this.graphControlsGroupBox);
-      this.topControlBox.Location = new System.Drawing.Point(3, 3);
-      this.topControlBox.Name = "topControlBox";
-      this.topControlBox.Size = new System.Drawing.Size(1066, 44);
-      this.topControlBox.TabIndex = 6;
-      // 
-      // graphControlsGroupBox
-      // 
-      this.graphControlsGroupBox.Controls.Add(this.lockGenealogyCheckBox);
-      this.graphControlsGroupBox.Controls.Add(this.highlightAllButton);
-      this.graphControlsGroupBox.Controls.Add(this.simpleLineagesCheckBox);
-      this.graphControlsGroupBox.Location = new System.Drawing.Point(1, -2);
-      this.graphControlsGroupBox.Name = "graphControlsGroupBox";
-      this.graphControlsGroupBox.Size = new System.Drawing.Size(98, 44);
-      this.graphControlsGroupBox.TabIndex = 11;
-      this.graphControlsGroupBox.TabStop = false;
-      this.graphControlsGroupBox.Text = "Graph controls";
-      // 
-      // lockGenealogyCheckBox
-      // 
-      this.lockGenealogyCheckBox.Appearance = System.Windows.Forms.Appearance.Button;
-      this.lockGenealogyCheckBox.Location = new System.Drawing.Point(66, 14);
-      this.lockGenealogyCheckBox.Name = "lockGenealogyCheckBox";
-      this.lockGenealogyCheckBox.Size = new System.Drawing.Size(24, 24);
-      this.lockGenealogyCheckBox.TabIndex = 17;
-      this.toolTip.SetToolTip(this.lockGenealogyCheckBox, "Lock genealogy");
-      this.lockGenealogyCheckBox.UseVisualStyleBackColor = true;
-      this.lockGenealogyCheckBox.CheckedChanged += new System.EventHandler(this.lockGenealogyCheckBox_CheckedChanged);
-      // 
-      // highlightAllButton
-      // 
-      this.highlightAllButton.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
-      this.highlightAllButton.Location = new System.Drawing.Point(6, 14);
-      this.highlightAllButton.Name = "highlightAllButton";
-      this.highlightAllButton.Size = new System.Drawing.Size(24, 24);
-      this.highlightAllButton.TabIndex = 13;
-      this.toolTip.SetToolTip(this.highlightAllButton, "Fitness gradient");
-      this.highlightAllButton.UseVisualStyleBackColor = true;
-      this.highlightAllButton.Click += new System.EventHandler(this.highlightAllButton_Click);
-      // 
-      // simpleLineagesCheckBox
-      // 
-      this.simpleLineagesCheckBox.Appearance = System.Windows.Forms.Appearance.Button;
-      this.simpleLineagesCheckBox.Location = new System.Drawing.Point(36, 14);
-      this.simpleLineagesCheckBox.Name = "simpleLineagesCheckBox";
-      this.simpleLineagesCheckBox.Size = new System.Drawing.Size(24, 24);
-      this.simpleLineagesCheckBox.TabIndex = 12;
-      this.toolTip.SetToolTip(this.simpleLineagesCheckBox, "Simple lineages");
-      this.simpleLineagesCheckBox.UseVisualStyleBackColor = true;
-      this.simpleLineagesCheckBox.CheckedChanged += new System.EventHandler(this.simpleLineagesCheckBox_CheckedChanged);
       // 
       // genealogyGraphChart
       // 
-      this.genealogyGraphChart.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
       this.genealogyGraphChart.BackColor = System.Drawing.SystemColors.Control;
-      this.genealogyGraphChart.Chart = null;
-      this.genealogyGraphChart.GenealogyGraph = null;
-      this.genealogyGraphChart.Location = new System.Drawing.Point(3, 51);
+      this.genealogyGraphChart.Chart = new Chart(0, 0, genealogyGraphChart.PreferredSize.Width, genealogyGraphChart.PreferredSize.Height);
+      this.genealogyGraphChart.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.genealogyGraphChart.Location = new System.Drawing.Point(0, 0);
       this.genealogyGraphChart.LockGenealogy = false;
       this.genealogyGraphChart.Name = "genealogyGraphChart";
       this.genealogyGraphChart.ScaleOnResize = true;
       this.genealogyGraphChart.SimpleLineages = false;
-      this.genealogyGraphChart.Size = new System.Drawing.Size(1066, 724);
-      this.genealogyGraphChart.TabIndex = 7;
+      this.genealogyGraphChart.Size = new System.Drawing.Size(150, 150);
+      this.genealogyGraphChart.TabIndex = 0;
       // 
-      // GenealogyGraphView
+      // SymbolicDataAnalysisGenealogyView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.Controls.Add(this.genealogyGraphChart);
-      this.Controls.Add(this.topControlBox);
-      this.Name = "GenealogyGraphView";
-      this.Size = new System.Drawing.Size(1072, 778);
-      this.topControlBox.ResumeLayout(false);
-      this.graphControlsGroupBox.ResumeLayout(false);
+      this.Name = "SymbolicDataAnalysisGenealogyView";
       this.ResumeLayout(false);
 
@@ -124,12 +54,5 @@
     #endregion
 
-    private System.Windows.Forms.ToolTip toolTip;
-    private System.Windows.Forms.Panel topControlBox;
-    private System.Windows.Forms.GroupBox graphControlsGroupBox;
-    private System.Windows.Forms.Button highlightAllButton;
-    private System.Windows.Forms.CheckBox simpleLineagesCheckBox;
-    private System.Windows.Forms.CheckBox lockGenealogyCheckBox;
-    private GenealogyGraphChart genealogyGraphChart;
-
+    private EvolutionTracking.Views.GenealogyGraphChart genealogyGraphChart;
   }
 }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/GenealogyGraphView.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/GenealogyGraphView.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/GenealogyGraphView.cs	(revision 10300)
@@ -1,50 +1,20 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Linq;
-using System.Windows.Forms;
-using HeuristicLab.Core.Views;
+﻿using HeuristicLab.Core.Views;
 using HeuristicLab.MainForm;
 
 namespace HeuristicLab.EvolutionTracking.Views {
-  [View("GenealogyGraph")]
-  [Content(typeof(GenealogyGraph), IsDefaultView = true)]
+  [View("GenealogyGraphView")]
+  [Content(typeof(GenealogyGraph), IsDefaultView = false)]
   public sealed partial class GenealogyGraphView : ItemView {
-    public new GenealogyGraph Content {
-      get { return (GenealogyGraph)base.Content; }
+    public new IGenealogyGraph Content {
+      get { return (IGenealogyGraph)base.Content; }
       set { base.Content = value; }
     }
 
-    public GenealogyGraphView()
-      : base() {
+    public GenealogyGraphView() {
       InitializeComponent();
-      // set button icons here because if set in the designer file, they get overwritten
-      this.highlightAllButton.Image = Common.Resources.VSImageLibrary.Gradient;
-      this.simpleLineagesCheckBox.Image = Common.Resources.VSImageLibrary.ArrowDown;
-      this.lockGenealogyCheckBox.Image = Common.Resources.VSImageLibrary.ProtectForm;
     }
 
     protected override void DeregisterContentEvents() {
       // TODO: Deregister your event handlers here
-      Content.GraphUpdated -= GenealogyGraphUpdated;
       base.DeregisterContentEvents();
     }
@@ -53,56 +23,26 @@
       base.RegisterContentEvents();
       // TODO: Register your event handlers here
-      Content.GraphUpdated += GenealogyGraphUpdated;
     }
 
     #region Event Handlers (Content)
     // TODO: Put event handlers of the content here
+    #endregion
+
     protected override void OnContentChanged() {
       base.OnContentChanged();
-      //      genealogyGraphChart.GenealogyGraph = Content ?? null;
+      if (Content == null) {
+      } else {
+        genealogyGraphChart.GenealogyGraph = Content;
+      }
     }
-    private void Content_GraphChanged(object sender, EventArgs e) {
-    }
+
     protected override void SetEnabledStateOfControls() {
       base.SetEnabledStateOfControls();
-      genealogyGraphChart.Enabled = Content != null;
+      // TODO: Enable or disable controls based on whether the content is null or the view is set readonly
     }
-    #endregion
 
     #region Event Handlers (child controls)
-    private void GenealogyGraphUpdated(object sender, EventArgs args) {
-      genealogyGraphChart.GenealogyGraph = Content;
-    }
-    void MatchNodesAndRepaint() {
-      genealogyGraphChart.Chart.UpdateEnabled = false;
-      genealogyGraphChart.ClearPrimitives(); // clear node colors
-
-      genealogyGraphChart.Chart.UpdateEnabled = true;
-      genealogyGraphChart.Chart.EnforceUpdate();
-    }
-
-    private void treeChart_SymbolicExpressionTreeNodeDoubleClicked(object sender, MouseEventArgs e) {
-    }
+    // TODO: Put event handlers of child controls here.
     #endregion
-    private void simpleLineagesCheckBox_CheckedChanged(object sender, EventArgs e) {
-      genealogyGraphChart.SimpleLineages = simpleLineagesCheckBox.Checked;
-    }
-
-    private void highlightAllButton_Click(object sender, EventArgs e) {
-    }
-
-    private void lockGenealogyCheckBox_CheckedChanged(object sender, EventArgs e) {
-      genealogyGraphChart.LockGenealogy = lockGenealogyCheckBox.Checked;
-    }
-
-    private void highlightRootParentsButton_Click(object sender, EventArgs e) {
-      var nodes = genealogyGraphChart.GenealogyGraph.Nodes.Where(n => n.InArcs != null && n.InArcs.Count == 2).Select(n => (GenealogyGraphNode)n.InArcs[0].Source).ToList();
-      genealogyGraphChart.HighlightNodes(nodes);
-    }
-
-    private void highlightSecondaryParentsButton_Click(object sender, EventArgs e) {
-      var nodes = genealogyGraphChart.GenealogyGraph.Nodes.Where(n => n.InArcs != null && n.InArcs.Count == 2).Select(n => (GenealogyGraphNode)n.InArcs[1].Source).ToList();
-      genealogyGraphChart.HighlightNodes(nodes);
-    }
   }
 }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/HeuristicLab.EvolutionTracking.Views-3.4.csproj
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/HeuristicLab.EvolutionTracking.Views-3.4.csproj	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/HeuristicLab.EvolutionTracking.Views-3.4.csproj	(revision 10300)
@@ -132,4 +132,10 @@
       <DependentUpon>Resources.resx</DependentUpon>
     </Compile>
+    <Compile Include="GenealogyGraphView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="GenealogyGraphView.Designer.cs">
+      <DependentUpon>GenealogyGraphView.cs</DependentUpon>
+    </Compile>
     <Compile Include="VisualGenealogyGraphArc.cs" />
     <Compile Include="VisualGenealogyGraphNode.cs" />
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/Plugin.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/Plugin.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking.Views/3.4/Plugin.cs	(revision 10300)
@@ -23,6 +23,6 @@
 
 namespace HeuristicLab.EvolutionaryTracking.Views {
-  [Plugin("HeuristicLab.EvolutionaryTracking.Views", "Provides controls and views for the evolution graph and related structures.", "3.4.2.7439")]
-  [PluginFile("HeuristicLab.EvolutionaryTracking.Views-3.4.dll", PluginFileType.Assembly)]
+  [Plugin("HeuristicLab.EvolutionTracking.Views", "Provides controls and views for the evolution graph and related structures.", "3.4.2.7439")]
+  [PluginFile("HeuristicLab.EvolutionTracking.Views-3.4.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Core.Views", "3.3")]
@@ -34,5 +34,5 @@
   [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
   [PluginDependency("HeuristicLab.Visualization", "3.3")]
-  [PluginDependency("HeuristicLab.EvolutionaryTracking", "3.4")]
+  [PluginDependency("HeuristicLab.EvolutionTracking", "3.4")]
   [PluginDependency("HeuristicLab.Problems.DataAnalysis.Symbolic", "3.4")]
 
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Analyzers/GenealogyAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Analyzers/GenealogyAnalyzer.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/Analyzers/GenealogyAnalyzer.cs	(revision 10300)
@@ -12,12 +12,10 @@
   [StorableClass]
   [Item("GenealogyAnalyzer", "An analyzer which performs the necessary instrumentation to record the evolution of a genetic algorithm.")]
-  public class GenealogyAnalyzer<TGraph, TVertex, TContent> : SingleSuccessorOperator, IAnalyzer
-    where TGraph : class, IGenealogyGraph<TVertex, TContent>
-    where TVertex : class, IGenealogyGraphNode<TContent>, new()
-    where TContent : class, IItem {
+  public class GenealogyAnalyzer<T> : SingleSuccessorOperator, IAnalyzer
+  where T : class,IItem {
 
-    private AfterCrossoverOperator<TGraph, TVertex, TContent> afterCrossoverOperator;
-    private AfterManipulatorOperator<TGraph, TVertex, TContent> afterManipulatorOperator;
-    private BeforeManipulatorOperator<TGraph, TVertex, TContent> beforeManipulatorOperator;
+    private AfterCrossoverOperator<T> afterCrossoverOperator;
+    private AfterManipulatorOperator<T> afterManipulatorOperator;
+    private BeforeManipulatorOperator<T> beforeManipulatorOperator;
     public string CrossoverParentsParameterName { get; set; }
     public string CrossoverChildParameterName { get; set; }
@@ -25,5 +23,5 @@
 
     public IScopeTreeLookupParameter<DoubleValue> QualityParameter;
-    public IScopeTreeLookupParameter<TContent> PopulationParameter;
+    public IScopeTreeLookupParameter<T> PopulationParameter;
 
     private const string PopulationParameterName = "Population";
@@ -94,14 +92,14 @@
       get { return GenerationsParameter.ActualValue; }
     }
-    public IGenealogyGraph<TVertex, TContent> GenealogyGraph {
+    public IGenealogyGraph GenealogyGraph {
       get {
         IResult result;
         if (!Results.ContainsKey(PopulationGraphParameterName)) {
-          result = new Result(PopulationGraphParameterName, new GenealogyGraph<TVertex, TContent>());
+          result = new Result(PopulationGraphParameterName, new GenealogyGraph());
           Results.Add(result);
         } else {
           result = Results[PopulationGraphParameterName];
         }
-        var graph = (GenealogyGraph<TVertex, TContent>)result.Value;
+        var graph = (IGenealogyGraph)result.Value;
         return graph;
       }
@@ -121,5 +119,5 @@
       Parameters.Add(new LookupParameter<IntValue>(GenerationsParameterName, "The number of generations so far."));
       Parameters.Add(new LookupParameter<ResultCollection>(ResultsParameterName));
-      PopulationParameter = new ScopeTreeLookupParameter<TContent>(PopulationParameterName);
+      PopulationParameter = new ScopeTreeLookupParameter<T>(PopulationParameterName);
       QualityParameter = new ScopeTreeLookupParameter<DoubleValue>(QualityParameterName);
       Parameters.Add(PopulationParameter);
@@ -127,7 +125,7 @@
     }
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new GenealogyAnalyzer<TGraph, TVertex, TContent>(this, cloner);
+      return new GenealogyAnalyzer<T>(this, cloner);
     }
-    protected GenealogyAnalyzer(GenealogyAnalyzer<TGraph, TVertex, TContent> original, Cloner cloner)
+    protected GenealogyAnalyzer(GenealogyAnalyzer<T> original, Cloner cloner)
       : base(original, cloner) {
     }
@@ -140,5 +138,5 @@
       if (Generations.Value == 0) {
         foreach (var individual in PopulationParameter.ActualValue) {
-          var vertex = new TVertex {
+          var vertex = new GenealogyGraphNode<T> {
             Content = individual,
             Rank = Generations.Value
@@ -149,5 +147,5 @@
         if (EnableCrossoverTracking.Value) {
           if (afterCrossoverOperator == null) {
-            afterCrossoverOperator = new AfterCrossoverOperator<TGraph, TVertex, TContent>();
+            afterCrossoverOperator = new AfterCrossoverOperator<T>();
             afterCrossoverOperator.ParentsParameter.ActualName = CrossoverParentsParameterName;
             afterCrossoverOperator.ChildParameter.ActualName = CrossoverChildParameterName;
@@ -159,9 +157,9 @@
         if (EnableManipulatorTracking.Value && Manipulator != null) {
           if (beforeManipulatorOperator == null) {
-            beforeManipulatorOperator = new BeforeManipulatorOperator<TGraph, TVertex, TContent>();
+            beforeManipulatorOperator = new BeforeManipulatorOperator<T>();
             beforeManipulatorOperator.ChildParameter.ActualName = ManipulatorChildParameterName;
           }
           if (afterManipulatorOperator == null) {
-            afterManipulatorOperator = new AfterManipulatorOperator<TGraph, TVertex, TContent>();
+            afterManipulatorOperator = new AfterManipulatorOperator<T>();
             afterManipulatorOperator.ChildParameter.ActualName = ManipulatorChildParameterName;
           }
@@ -173,9 +171,9 @@
         // add missing elite individuals in the current generation 
         // TODO: optimize for speed
-        var currGen = new HashSet<TContent>(GenealogyGraph.Ranks[Generations.Value].Select(x => x.Content));
+        var currGen = new HashSet<T>(GenealogyGraph.Ranks[Generations.Value].Cast<IGenealogyGraphNode<T>>().Select(x => x.Content));
         foreach (var individual in PopulationParameter.ActualValue) {
           if (currGen.Contains(individual)) continue;
           // it is an elite which was already added to the graph in the previous generation
-          var vertex = new TVertex {
+          var vertex = new GenealogyGraphNode<T> {
             Content = individual,
             Rank = Generations.Value,
@@ -189,5 +187,5 @@
       var qualities = QualityParameter.ActualValue.ToList();
       for (int i = 0; i < population.Count; ++i) {
-        foreach (var v in GenealogyGraph[population[i]]) {
+        foreach (var v in GenealogyGraph[population[i]].Cast<IGenealogyGraphNode<T>>()) {
           v.Quality = qualities[i].Value;
         }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/DirectedGraph/DirectedGraph.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/DirectedGraph/DirectedGraph.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/DirectedGraph/DirectedGraph.cs	(revision 10300)
@@ -31,12 +31,15 @@
   [Item("DirectedGraph", "Generic class representing a directed graph with custom vertices and content")]
   [StorableClass]
-  public class DirectedGraph<TVertex> : Item, IDirectedGraph<TVertex> where TVertex : class,IVertex {
+  public class DirectedGraph : Item, IDirectedGraph {
     [Storable]
-    protected readonly List<TVertex> nodes; // for performance reasons, maybe this should be a linked list (fast remove)
-    public List<TVertex> Nodes {
+    protected readonly List<IVertex> nodes; // for performance reasons, maybe this should be a linked list (fast remove)
+    public List<IVertex> Nodes {
       get { return nodes; }
     }
+    [Storable]
+    private readonly Dictionary<object, List<IVertex>> contentMap;
     public DirectedGraph() {
-      nodes = new List<TVertex>();
+      nodes = new List<IVertex>();
+      contentMap = new Dictionary<object, List<IVertex>>();
     }
     [StorableConstructor]
@@ -44,16 +47,27 @@
       : base(serializing) {
     }
-    protected DirectedGraph(DirectedGraph<TVertex> original, Cloner cloner)
+    protected DirectedGraph(DirectedGraph original, Cloner cloner)
       : base(original, cloner) {
-      nodes = new List<TVertex>(original.Nodes);
+      nodes = new List<IVertex>(original.Nodes);
+      contentMap = new Dictionary<object, List<IVertex>>(original.contentMap);
     }
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new DirectedGraph<TVertex>(this, cloner);
+      return new DirectedGraph(this, cloner);
     }
-    public bool Contains(TVertex t) {
+    public bool Contains(IVertex t) {
       return nodes.Contains(t);
     }
 
-    public virtual bool Any(Func<TVertex, bool> predicate) {
+    public bool Contains(object content) {
+      return contentMap.ContainsKey(content);
+    }
+    public List<IVertex> this[object key] {
+      get {
+        List<IVertex> result;
+        contentMap.TryGetValue(key, out result);
+        return result;
+      }
+    }
+    public virtual bool Any(Func<IVertex, bool> predicate) {
       return nodes.Any(predicate);
     }
@@ -61,14 +75,15 @@
       get { return !nodes.Any(); }
     }
-
     public virtual void Clear() {
       nodes.Clear();
     }
-
-    public virtual void AddVertex(TVertex vertex) {
+    public virtual void AddVertex(IVertex vertex) {
       Nodes.Add(vertex);
+      if (!contentMap.ContainsKey(vertex.Content))
+        contentMap[vertex.Content] = new List<IVertex>();
+      contentMap[vertex.Content].Add(vertex);
     }
 
-    public virtual void RemoveVertex(TVertex vertex) {
+    public virtual void RemoveVertex(IVertex vertex) {
       nodes.Remove(vertex);
     }
@@ -77,58 +92,3 @@
     }
   }
-
-  [Item("Directed graph", "Generic directed graph base class.")]
-  [StorableClass]
-  public class DirectedGraph<TVertex, TContent> : DirectedGraph<TVertex>, IDirectedGraph<TVertex, TContent>
-    where TVertex : class,IVertex<TContent>
-    where TContent : class,IItem {
-
-    [StorableConstructor]
-    protected DirectedGraph(bool deserializing) : base(deserializing) { }
-
-    [Storable]
-    private readonly Dictionary<TContent, List<TVertex>> contentMap; // reverse mapping of content to the actual vertices
-    public DirectedGraph() {
-      contentMap = new Dictionary<TContent, List<TVertex>>();
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new DirectedGraph<TVertex, TContent>(this, cloner);
-    }
-    protected DirectedGraph(DirectedGraph<TVertex, TContent> original, Cloner cloner)
-      : base(original, cloner) {
-      contentMap = new Dictionary<TContent, List<TVertex>>(original.contentMap);
-    }
-    public bool Contains(TContent content) {
-      return contentMap.ContainsKey(content);
-    }
-    public List<TVertex> this[TContent key] {
-      get {
-        List<TVertex> result = null;
-        contentMap.TryGetValue(key, out result);
-        return result;
-      }
-      //      set {
-      //        contentMap[key] = value;
-      //      }
-    }
-    public override void Clear() {
-      contentMap.Clear();
-      base.Clear();
-    }
-    public override void AddVertex(TVertex vertex) {
-      if (contentMap.ContainsKey(vertex.Content)) {
-        contentMap[vertex.Content].Add(vertex);
-      } else {
-        contentMap[vertex.Content] = new List<TVertex> { vertex };
-      }
-      base.AddVertex(vertex);
-    }
-
-    public override void RemoveVertex(TVertex vertex) {
-      if (contentMap.ContainsKey(vertex.Content)) {
-        contentMap[vertex.Content].Remove(vertex);
-      }
-      base.RemoveVertex(vertex);
-    }
-  }
 }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/DirectedGraph/Interfaces/IDirectedGraph.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/DirectedGraph/Interfaces/IDirectedGraph.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/DirectedGraph/Interfaces/IDirectedGraph.cs	(revision 10300)
@@ -25,18 +25,13 @@
 
 namespace HeuristicLab.EvolutionTracking {
-  public interface IDirectedGraph : IItem { }
-  public interface IDirectedGraph<TVertex> : IDirectedGraph
-    where TVertex : class, IVertex {
-    bool Contains(TVertex vertex);
-    bool Any(Func<TVertex, bool> predicate); // graph contains any nodes matching the given predicate?
-    void Clear(); // clear graph
-    void AddVertex(TVertex vertex);
-    void RemoveVertex(TVertex vertex); // remove node if contained in the graph
-    List<TVertex> Nodes { get; }
-  }
-  public interface IDirectedGraph<TVertex, in TContent> : IDirectedGraph<TVertex>
-    where TVertex : class, IVertex
-    where TContent : class, IItem {
-    bool Contains(TContent content); // graph contains node with given content?
+  public interface IDirectedGraph : IItem {
+    bool Contains(IVertex vertex);
+    bool Any(Func<IVertex, bool> predicate);
+    void Clear();
+    void AddVertex(IVertex vertex);
+    void RemoveVertex(IVertex vertex);
+    List<IVertex> Nodes { get; }
+    List<IVertex> this[object content] { get; }
+    bool Contains(object content);
   }
 }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/DirectedGraph/Interfaces/IVertex.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/DirectedGraph/Interfaces/IVertex.cs	(revision 10299)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.EvolutionTracking/3.4/DirectedGraph/Interfaces/IVertex.cs	(revision 10300)
@@ -40,9 +40,11 @@
     void AddReverseArc(IVertex target, double weight = 0.0, object content = null);
     void AddReverseArc(IArc arc);
+
+    object Content { get; set; }
   }
 
   public interface IVertex<T> : IVertex
   where T : class,IItem {
-    T Content { get; set; }
+    new T Content { get; set; }
   }
 }
